package com.dacober.avar;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.actionbarsherlock.app.ActionBar;
import com.actionbarsherlock.app.SherlockFragmentActivity;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;

public class AvarInfo extends SherlockFragmentActivity {

	// Declaramos las variables
	private String name;
	private TextView nomEmp, dirEmp, telEmp, webEmp, etiwebEmp;
	private Button backMap, navigation;
	private String lat, lng;
	private FavoritosDataSource dataSource;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.avar_info);

		// Habilitamos el boton de volver en la actionbar
		getSupportActionBar().setDisplayOptions(ActionBar.DISPLAY_HOME_AS_UP,
				ActionBar.DISPLAY_HOME_AS_UP);

		// Abrimos la base de datos
		dataSource = new FavoritosDataSource(this);
		dataSource.open();

		// Asignamos cada TextView y Button con su id correspondiente
		nomEmp = (TextView) findViewById(R.id.nombre_empresa);
		dirEmp = (TextView) findViewById(R.id.direccion);
		telEmp = (TextView) findViewById(R.id.telefono);
		webEmp = (TextView) findViewById(R.id.web);
		etiwebEmp = (TextView) findViewById(R.id.txtWeb);
		backMap = (Button) findViewById(R.id.btnMapa);
		navigation = (Button) findViewById(R.id.btnNavigation);

		// Recuperamos la info del intent sobre que empresa se ha pulsado
		Intent i = getIntent();
		Bundle b = i.getExtras();

		// Comprobamos que la info del intent no sea null
		if (b != null) {
			name = (String) b.get("name");
		}

		nomEmp.setText(name);

		// Dependiendo de que empresa sea, mostramos una info u otra
		if (name.equals("MULTICOPIA VALENCIA, S.L.")) {
			dirEmp.setText("C/ Ramon Llul, 37, 46021 Valencia");
			telEmp.setText("963 60 84 97");
			webEmp.setText("www.multicopiavalencia.com");
			lat = "39.47753831308021";
			lng = "-0.3465830999999753";
		} else if (name.equals("DIAZOTEC, S.A")) {
			dirEmp.setText("C/ Taqugrafo Mart, 18, 46005 Valencia");
			telEmp.setText("963 95 39 00");
			webEmp.setText("www.diazotec.es");
			lat = "39.464886513074326";
			lng = "-0.37047199999994973";
		} else if (name.equals("FOTOCOPIAS BURJASSOT")) {
			dirEmp.setText("C/ Hernn Cortes, 6 local 10 (Paseo Rajolar), 46100 Burjassot (Valencia)");
			telEmp.setText("963 90 46 25");
			webEmp.setText("www.fotocopiasburjassot.es");
			lat = "39.51162301309609";
			lng = "-0.41910889999996925";
		} else if (name.equals("TURBOCOPIAS ENRIQUE PEIRO, S.L.")) {
			dirEmp.setText("C/ Doctor Moliner, 50 (Facultad de Ciencias), 46100 Burjassot (Valencia)");
			telEmp.setText("963 54 33 50");
			webEmp.setText("www.turbocopias.com");
			lat = "39.50803572220904";
			lng = "-0.42035893706360516";
		} else if (name.equals("REPROEXPRES, S.L.")) {
			dirEmp.setText("Carrer d'Albalat dels Tarongers, 36, 46021 Valencia");
			telEmp.setText("96 361 29 39");
			webEmp.setText("www.reproexpres.com");
			lat = "39.478173813080474";
			lng = "-0.3468074999999544";
		} else if (name.equals("COPI BALBI, SL")) {
			dirEmp.setText("C/ Clariano, 17, 46021 Valencia");
			telEmp.setText("963 69 19 90");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.47807851308046";
			lng = "-0.35164910000003147";
		} else if (name.equals("COPYCOLOR")) {
			dirEmp.setText("C/ Norte, 1, 46600 Alzira (Valencia)");
			telEmp.setText("962 41 59 73");
			webEmp.setText("www.copycoloralzira.es");
			lat = "39.15370872361409";
			lng = "-0.4340142601493069";
		} else if (name.equals("COPISTERIA GINER, S.L.")) {
			dirEmp.setText("C/ Cervantes, 7 Bajo, 46680 Algemes (Valencia)");
			telEmp.setText("962 42 05 61");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.19225241294806";
			lng = "-0.43702029999997194";
		// Revisar las coordenadas de Fotorapid porque estan mal
		} else if (name.equals("FOTORAPID")) {
			dirEmp.setText("Crta. De Torrente, 12, 46950 Chirivella (Valencia)");
			telEmp.setText("963 79 12 75");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.46881556307615";
			lng = "-0.4288256500000216";
		} else if (name.equals("GRUXO M. IMPRENTA DIGITAL, SL")) {
			dirEmp.setText("C/ Emilio Bar, 88, 46020 Valencia");
			telEmp.setText("963 32 15 98");
			webEmp.setText("www.gruxo.com");
			lat = "39.4912441130866";
			lng = "-0.3590116999999964";
		} else if (name.equals("FOTOCOPIAS PL, S.L.")) {
			dirEmp.setText("Pza. Del Regne, 3, 46600 Alzira (Valencia)");
			telEmp.setText("962 45 52 10");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.14934853097309";
			lng = "-0.43936191437274896";
		} else if (name.equals("COPISTERIA VELZQUEZ")) {
			dirEmp.setText("C/ Padre Mariana, 15 Bajo, 03004 Alicante");
			telEmp.setText("965 20 48 92");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "38.351138016014374";
			lng = "-0.48669794110445697";
		} else if (name.equals("FOTO CINE MILA")) {
			dirEmp.setText("Avda. del Puerto, 247, 46011 Valencia");
			telEmp.setText("963 67 28 44");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.46138101307272";
			lng = "-0.3368494000000055";
		} else if (name.equals("COPISTERIA FORMAT, S.L.")) {
			dirEmp.setText("C/ Escalante, 13, 12006 Castelln");
			telEmp.setText("964 03 77 77");
			webEmp.setText("www.copisteriaformat.com");
			lat = "39.979681213315466";
			lng = "-0.04481529999998202";
		} else if (name.equals("LLIRCOP")) {
			dirEmp.setText("C/ Metge Vicent Portols, 10, 46160 Lliria (Valencia)");
			telEmp.setText("962 79 25 37");
			webEmp.setText("www.llircop.com");
			lat = "39.62683081314978";
			lng = "-0.5950540000000046";
		} else if (name.equals("GAMMA SERV. REPROGRFICOS INTEGRALES, S.L.")) {
			dirEmp.setText("C/ Cottolengo, 25, 03690 San Vicente del Raspeig (Alicante)");
			telEmp.setText("965 67 19 87");
			webEmp.setText("www.1gamma.com");
			lat = "38.3868376125806";
			lng = "-0.5092712000000574";
		} else if (name.equals("AREA GRAFICA DIGITAL ALCOY, S.L.")) {
			dirEmp.setText("Carrer Roger de Llria, 2, 03801 Alcoy (Alicante)");
			telEmp.setText("96 554 20 60");
			webEmp.setText("www.areagraficadigital.es");
			lat = "38.696180312720806";
			lng = "-0.47574439999993956";
		} else if (name.equals("M.N. COPIES, S.L.")) {
			dirEmp.setText("Paseo Morella, 42 Bajo, 12004 Castelln");
			telEmp.setText("964 25 23 15");
			webEmp.setText("www.mnimpresion.com");
			lat = "39.98939181332011";
			lng = "-0.04899679999994078";
		} else if (name.equals("GRAFICAS ALHOR")) {
			dirEmp.setText("C/ Gasc Oliag, 10, 46010 Valencia");
			telEmp.setText("963 39 25 12");
			webEmp.setText("www.graficas-ancaba.es");
			lat = "39.47870271308076";
			lng = "-0.35716419999994287";
		} else if (name.equals("COPISTERIA ABASTOS")) {
			dirEmp.setText("C/ Alberique, 29, 46008 Valencia");
			telEmp.setText("96 385 59 78");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.467797313075664";
			lng = "-0.3892221999999492";
		} else if (name.equals("MULTICOLOR")) {
			dirEmp.setText("C/ San Mateo, 27, 03012 Alicante");
			telEmp.setText("96 591 05 23");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "38.357961212567574";
			lng = "-0.4785957999999937";
		} else if (name.equals("PAPELERIA ESTUDI")) {
			dirEmp.setText("C/ Cullera, 60, 46730 Grau de Ganda (Valencia)");
			telEmp.setText("962 84 68 46");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "38.99636371285796";
			lng = "-0.16394690000004175";
		} else if (name.equals("REPROGRAFIA B.V., S.L.")) {
			dirEmp.setText("Pasaje Dr. Serra, 3 Bajo, 46004 Valencia");
			telEmp.setText("963 52 24 83");
			webEmp.setText("www.reprografiabv.com");
			lat = "39.466706813075156";
			lng = "-0.37535139999999956";
		} else if (name.equals("SAMARRETES PAPERS")) {
			dirEmp.setText("C/ Sixto Cmara, 14, 46100 Burjassot (Valencia)");
			telEmp.setText("963 90 23 06");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.50720831309405";
			lng = "-0.41511579999996684";
		} else if (name.equals("URIBE DIGITAL")) {
			dirEmp.setText("Plaza de Espaa, 6, 46007 Valencia");
			telEmp.setText("963 80 23 37");
			webEmp.setText("www.uribedigital.com");
			lat = "39.465473913074604";
			lng = "-0.38200370000004114";
		} else if (name.equals("PANTERA ROSA")) {
			dirEmp.setText("C/ Guardia Civil, 4, 46020 Valencia");
			telEmp.setText("963 32 12 35");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.48268981308261";
			lng = "-0.3598785000000362";
		} else if (name.equals("VENTURA COPIN, S.L.")) {
			dirEmp.setText("Avda. Cam dOnda, 33, 12530 Burriana (Castelln)");
			telEmp.setText("964 51 22 08");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.8920136132742";
			lng = "-0.08919890000004216";
		} else if (name.equals("PAPELERIA COPISTERIA AEROCLUB, S.L.")) {
			dirEmp.setText("Avda. Alicante, 105 (Frente Universidad), 03690 San Vicente del Raspeig (Alicante)");
			telEmp.setText("965 67 13 89");
			webEmp.setText("www.aeroclubcopisteria.com");
			lat = "38.38545361257999";
			lng = "-0.5084511999999677";
		} else if (name.equals("REPROGRAFIA FACULTAT")) {
			dirEmp.setText("Av. Blasco Ibez, 21 (Facultad de Psicologa), 46010 Valencia");
			telEmp.setText("963 62 22 48");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.47819221308048";
			lng = "-0.3605185999999776";
		} else if (name.equals("COPISTERIA EL CUQUET")) {
			dirEmp.setText("C/ Pontet, 29 bajo, 46440 Almussafes (Valencia)");
			telEmp.setText("961 78 10 52");
			etiwebEmp.setVisibility(View.GONE);
			webEmp.setVisibility(View.GONE);
			lat = "39.28872291299263";
			lng = "-0.4150439999999662";
		} else if (name.equals("LA PALLERA")) {
			dirEmp.setText("C/ Literato Azorn, 18, 46910 Benetsser (Valencia)");
			telEmp.setText("963 75 06 92");
			webEmp.setText("www.lapallera.com");
			lat = "39.41938051305317";
			lng = "-0.3979229999999916";
		}

		// Damos funcionalidad a los botones de volver al mapa e ir a navigation
		// para obtener la ruta de llegada a la direccin
		backMap.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				startActivity(new Intent(AvarInfo.this, AvarMain.class));
			}
		});

		navigation.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				Intent intent = new Intent(android.content.Intent.ACTION_VIEW,
						Uri.parse("google.navigation:q=" + lat + "," + lng));
				startActivity(intent);
			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getSupportMenuInflater();
		inflater.inflate(R.menu.actionbar_menu_info, menu);
		return super.onCreateOptionsMenu(menu);
	}

	// Otorgamos funcionalidad a los botones de la ActionBar
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		switch (item.getItemId()) {
		case R.id.actionbar_share:

			Intent intent = new Intent(Intent.ACTION_SEND);
			intent.setType("text/plain");
			intent.putExtra(Intent.EXTRA_SUBJECT, name + ", "
					+ "http://maps.google.com/maps?q=" + lat + "," + lng);
			intent.putExtra(Intent.EXTRA_TEXT, "Reprografa asociada a Avar");
			startActivity(Intent.createChooser(intent, "Compartir"));
			;
			break;
		case R.id.actionbar_favoritos:

			dataSource.crearFavorito(name);
			Toast.makeText(AvarInfo.this, "Reprografia aadida a Favoritos",
					Toast.LENGTH_LONG).show();

			;
			break;
		case android.R.id.home:
			finish();
			;
			break;
		default:
			return super.onOptionsItemSelected(item);
		}

		return true;
	}
}
