package com.dacober.avar;

import android.app.Dialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.view.View;
import android.view.WindowManager;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;

import com.actionbarsherlock.app.SherlockFragmentActivity;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuInflater;
import com.actionbarsherlock.view.MenuItem;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.GoogleMap.OnInfoWindowClickListener;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.sherlock.navigationdrawer.compat.SherlockActionBarDrawerToggle;

public class AvarMain extends SherlockFragmentActivity implements
		LocationListener {

	// Declaramos las variables
	DrawerLayout mDrawerLayout;
	ListView mDrawerList;
	SherlockActionBarDrawerToggle mDrawerToggle;
	MenuListAdapter mMenuAdapter;
	private String[] title;
	private String prefer1, prefer3;
	private boolean prefer2;
	private int[] icon;
	private CharSequence mDrawerTitle;
	private CharSequence mTitle;
	private CharSequence copymTitle;
	private boolean flag = false;
	private boolean menuOff = false;
	private boolean llamada = false;

	Fragment fragmentCA = new FragmentConAvar();
	Fragment fragmentFA = new FragmentFavAvar();
	Fragment fragmentPD = new FragmentPDAvar();
	Fragment fragmentPatro = new FragmentPatrocinador();

	private GoogleMap googleMap;
	private Animation animacionPatrocinadores;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.avar_main);

		// Obtenemos el estado de Google Play Services
		int status = GooglePlayServicesUtil
				.isGooglePlayServicesAvailable(getBaseContext());

		// Segn el estado
		if (status != ConnectionResult.SUCCESS) { // Google Play Services no
													// esta disponible

			int requestCode = 10;
			Dialog dialog = GooglePlayServicesUtil.getErrorDialog(status, this,
					requestCode);
			dialog.show();

		} else { // Google Play Services esta disponible

			googleMap = ((SupportMapFragment) getSupportFragmentManager()
					.findFragmentById(R.id.mapa)).getMap();

			// Comprobamos los ajustes
			SharedPreferences pref = PreferenceManager
					.getDefaultSharedPreferences(AvarMain.this);

			prefer1 = pref.getString("opcion1", "Nm");
			prefer2 = pref.getBoolean("opcion2", false);
			prefer3 = pref.getString("opcion3", "Mp");
			comprobarPreferencias(prefer1, prefer2);

			// Habilitamos MyLocation Layer de Google Map
			googleMap.setMyLocationEnabled(true);

			// Deshabilitamos el icono de Current Location del mapa para
			// habilitar solo el de la actionbar
			googleMap.getUiSettings().setMyLocationButtonEnabled(false);

			// Llamamos a la funcin que dibuja los iconos con las posiciones en
			// el mapa
			setMarkers();

			// Damos funcionalidad al evento de pulsacin de un globo del
			// marcador
			googleMap
					.setOnInfoWindowClickListener(new OnInfoWindowClickListener() {
						@Override
						public void onInfoWindowClick(Marker marker) {
							Intent i = new Intent(AvarMain.this, AvarInfo.class);
							i.putExtra("name", marker.getTitle());
							i.putExtra("geoposition", marker.getPosition());
							startActivity(i);

						}
					});

			// Llamamos a la funcin que nos proporciona nuestra localizacin
			// actual
			obtenerCurrentLocation();
		}

		// Cogemos el ttulo
		mTitle = mDrawerTitle = getTitle();

		// Generamos los ttulos
		title = new String[] { "Conoce AVAR", "Mapa", "Por distancia",
				"Favoritos", "Ajustes", "Patrocinadores" };

		// Generamos los iconos
		icon = new int[] { R.drawable.ic_printer_white,
				R.drawable.ic_action_map_white, R.drawable.ic_direction,
				R.drawable.ic_action_favorite_white,
				R.drawable.ic_action_settings, R.drawable.ic_powered };

		// Asiganamos las variables con su identificador
		mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);

		mDrawerList = (ListView) findViewById(R.id.left_drawer);

		// Preparamos la Navigation Drawer
		mDrawerLayout.setDrawerShadow(R.drawable.drawer_shadow,
				GravityCompat.START);
		
		mMenuAdapter = new MenuListAdapter(AvarMain.this, title, icon);

		mDrawerList.setAdapter(mMenuAdapter);

		mDrawerList.setOnItemClickListener(new DrawerItemClickListener());

		mDrawerToggle = new SherlockActionBarDrawerToggle(this, mDrawerLayout,
				R.drawable.ic_drawer, R.string.drawer_open,
				R.string.drawer_close) {

			public void onDrawerClosed(View view) {
				// TODO Auto-generated method stub

				// Volvemos a comprobar las preferencias, y si han cambiado,
				// cambiar la vista del mapa tambien
				if (flag) {
					SharedPreferences pref = PreferenceManager
							.getDefaultSharedPreferences(AvarMain.this);

					prefer1 = pref.getString("opcion1", "Nm");
					prefer2 = pref.getBoolean("opcion2", false);
					comprobarPreferencias(prefer1, prefer2);
					flag = false;
				}

				super.onDrawerClosed(view);
				supportInvalidateOptionsMenu();
			}

			public void onDrawerOpened(View drawerView) {
				// Set the title on the action when drawer open
				getSupportActionBar().setTitle(mDrawerTitle);
				super.onDrawerOpened(drawerView);
				supportInvalidateOptionsMenu();
			}
		};

		mDrawerLayout.setDrawerListener(mDrawerToggle);

		// Habilitamos los botones de la ActionBar
		getSupportActionBar().setHomeButtonEnabled(true);
		getSupportActionBar().setDisplayHomeAsUpEnabled(true);

		if (savedInstanceState == null) {

			/**
			 * Dependiendo de las preferencias del usuario, iniciamos la
			 * aplicacin con una pantalla u otra
			 */
			try {
				if (prefer3.equals("Mp"))
					selectItem(1);
				else if (prefer3.equals("Ca"))
					selectItem(0);
				else if (prefer3.equals("Pd"))
					selectItem(2);
				else if (prefer3.equals("Fv"))
					selectItem(3);
				else if (prefer3.equals("Pa"))
					selectItem(5);
			} catch (Exception e) {
				selectItem(1);
			}
		}

		// Animacin de los patrocinadores
		animacionPatrocinadores = AnimationUtils.loadAnimation(this,
				R.anim.desplazamiento);

		TextView patrocinador = (TextView) findViewById(R.id.patrocinador);
		patrocinador.startAnimation(animacionPatrocinadores);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getSupportMenuInflater();
		inflater.inflate(R.menu.actionbar_menu, menu);
		return super.onCreateOptionsMenu(menu);
	}

	// Otorgamos funcionalidad a los botones de la ActionBar
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		if (item.getItemId() == android.R.id.home) {

			if (mDrawerLayout.isDrawerOpen(mDrawerList)) {
				mDrawerLayout.closeDrawer(mDrawerList);

				/**
				 * Solucionamos el bug del ttulo, si alguien abre la navigation
				 * drawer y no selecciona ningn item, hacemos que aparezca de
				 * nuevo el titulo del item actual y no el nombre de AVAR
				 */
				if (getSupportActionBar().getTitle().equals("AVAR")) {
					getSupportActionBar().setTitle(copymTitle);
				}

			} else {
				mDrawerLayout.openDrawer(mDrawerList);
			}
		}

		switch (item.getItemId()) {
		case R.id.actionbar_current_position:
			obtenerCurrentLocation();
			;
			break;
		default:
			return super.onOptionsItemSelected(item);
		}

		return true;
	}

	// Recogemos el evento Click del ListView
	private class DrawerItemClickListener implements
			ListView.OnItemClickListener {
		@Override
		public void onItemClick(AdapterView<?> parent, View view, int position,
				long id) {
			selectItem(position);
		}
	}

	private void selectItem(int position) {

		FragmentTransaction ft = getSupportFragmentManager().beginTransaction();

		// Posicin seleccionada
		switch (position) {
		case 0:
			menuOff = true;
			supportInvalidateOptionsMenu();
			ft.replace(R.id.mapa, fragmentCA);
			break;
		case 1:
			menuOff = false;
			if (llamada) {
				ft.remove(fragmentCA);
				ft.remove(fragmentFA);
				ft.remove(fragmentPD);
				ft.remove(fragmentPatro);
			}
			llamada = true;
			break;
		case 2:
			menuOff = true;
			supportInvalidateOptionsMenu();
			ft.replace(R.id.mapa, fragmentPD);
			break;
		case 3:
			menuOff = true;
			supportInvalidateOptionsMenu();
			ft.replace(R.id.mapa, fragmentFA);
			break;
		case 4:
			flag = true;
			startActivity(new Intent(AvarMain.this, OpcionesPreferencias.class));
			break;
		case 5:
			menuOff = true;
			supportInvalidateOptionsMenu();
			ft.replace(R.id.mapa, fragmentPatro);
			break;
		}
		ft.commit();
		mDrawerList.setItemChecked(position, true);

		// Cogemos el ttulo de la posicion seleccionada
		if (position != 4)
			setTitle(title[position]);
		else if (position == 4)
			setTitle(copymTitle);
		// Cerramos el drawer
		mDrawerLayout.closeDrawer(mDrawerList);
	}

	@Override
	public boolean onPrepareOptionsMenu(Menu menu) {

		boolean menuAbierto = mDrawerLayout.isDrawerOpen(mDrawerList);

		if (menuAbierto)
			menu.findItem(R.id.actionbar_current_position).setVisible(false);
		else if (!menuAbierto && !menuOff)
			menu.findItem(R.id.actionbar_current_position).setVisible(true);
		else if (!menuAbierto && menuOff)
			menu.findItem(R.id.actionbar_current_position).setVisible(false);

		return super.onPrepareOptionsMenu(menu);
	}

	@Override
	protected void onPostCreate(Bundle savedInstanceState) {
		super.onPostCreate(savedInstanceState);
		mDrawerToggle.syncState();
	}

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
		mDrawerToggle.onConfigurationChanged(newConfig);
	}

	@Override
	public void setTitle(CharSequence title) {
		mTitle = title;
		copymTitle = title;
		getSupportActionBar().setTitle(mTitle);
	}

	/** Funcin con la cual obtenemos nuestra posicin actual en el mapa */
	public void obtenerCurrentLocation() {
		
		LocationManager locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);

		// Creamos un objeto Criteria para seleccionar el mejor proveedor a cada instante
		Criteria criteria = new Criteria();

		String provider = locationManager.getBestProvider(criteria, true);

		// Obtenemos la ltima posicin conocida
		Location location = locationManager.getLastKnownLocation(provider);

		if (location != null) {
			double latitude = location.getLatitude();

			double longitude = location.getLongitude();

			LatLng latLng = new LatLng(latitude, longitude);

			// Mostramos la posicin actual
			googleMap.moveCamera(CameraUpdateFactory.newLatLng(latLng));

			// Introducimos Zoom en el mapa
			googleMap.animateCamera(CameraUpdateFactory.zoomTo(13));

		}

		locationManager.requestLocationUpdates(provider, 20000, 0, this);
	}

	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
	}

	@Override
	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub
	}

	@Override
	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub
	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
	}

	/** Funciones con las que dibujamos los marcadores en el mapa */
	public void setMarkers() {

		Double lat, lng;
		String name;

		// MULTICOPIA VALENCIA, S.L.
		lat = 39.47753831308021;
		lng = -0.3465830999999753;
		name = "MULTICOPIA VALENCIA, S.L.";

		drawMarkers(lat, lng, name);

		// DIAZOTEC, S.A
		lat = 39.464886513074326;
		lng = -0.37047199999994973;
		name = "DIAZOTEC, S.A";

		drawMarkers(lat, lng, name);

		// FOTOCOPIAS BURJASSOT
		lat = 39.51162301309609;
		lng = -0.41910889999996925;
		name = "FOTOCOPIAS BURJASSOT";

		drawMarkers(lat, lng, name);

		// TURBOCOPIAS ENRIQUE PEIRO, S.L.
		lat = 39.50803572220904;
		lng = -0.42035893706360516;
		name = "TURBOCOPIAS ENRIQUE PEIRO, S.L.";

		drawMarkers(lat, lng, name);

		// REPROEXPRES, S.L.
		lat = 39.478173813080474;
		lng = -0.3468074999999544;
		name = "REPROEXPRES, S.L.";

		drawMarkers(lat, lng, name);

		// COPI BALBI, SL
		lat = 39.47807851308046;
		lng = -0.35164910000003147;
		name = "COPI BALBI, SL";

		drawMarkers(lat, lng, name);

		// COPYCOLOR
		lat = 39.15370872361409;
		lng = -0.4340142601493069;
		name = "COPYCOLOR";

		drawMarkers(lat, lng, name);

		// COPISTERIA GINER, S.L.
		lat = 39.19225241294806;
		lng = -0.43702029999997194;
		name = "COPISTERIA GINER, S.L.";

		drawMarkers(lat, lng, name);

		// FOTORAPID
		lat = 39.46881556307615;
		lng = -0.4288256500000216;
		name = "FOTORAPID";

		drawMarkers(lat, lng, name);

		// GRUXO M. IMPRENTA DIGITAL, SL
		lat = 39.4912441130866;
		lng = -0.3590116999999964;
		name = "GRUXO M. IMPRENTA DIGITAL, SL";

		drawMarkers(lat, lng, name);

		// FOTOCOPIAS PL, S.L.
		lat = 39.14934853097309;
		lng = -0.43936191437274896;
		name = "FOTOCOPIAS PL, S.L.";

		drawMarkers(lat, lng, name);

		// COPISTERIA VELZQUEZ
		lat = 38.351138016014374;
		lng = -0.48669794110445697;
		name = "COPISTERIA VELZQUEZ";

		drawMarkers(lat, lng, name);

		// FOTO CINE MILA
		lat = 39.46138101307272;
		lng = -0.3368494000000055;
		name = "FOTO CINE MILA";

		drawMarkers(lat, lng, name);

		// COPISTERIA FORMAT, S.L.
		lat = 39.979681213315466;
		lng = -0.04481529999998202;
		name = "COPISTERIA FORMAT, S.L.";

		drawMarkers(lat, lng, name);

		// LLIRCOP
		lat = 39.62683081314978;
		lng = -0.5950540000000046;
		name = "LLIRCOP";

		drawMarkers(lat, lng, name);

		// GAMMA SERV. REPROGRFICOS INTEGRALES, S.L.
		lat = 38.3868376125806;
		lng = -0.5092712000000574;
		name = "GAMMA SERV. REPROGRFICOS INTEGRALES, S.L.";

		drawMarkers(lat, lng, name);

		// AREA GRAFICA DIGITAL ALCOY, S.L.
		lat = 38.696180312720806;
		lng = -0.47574439999993956;
		name = "AREA GRAFICA DIGITAL ALCOY, S.L.";

		drawMarkers(lat, lng, name);

		// M.N. COPIES, S.L.
		lat = 39.98939181332011;
		lng = -0.04899679999994078;
		name = "M.N. COPIES, S.L.";

		drawMarkers(lat, lng, name);

		// GRAFICAS ALHOR
		lat = 39.47870271308076;
		lng = -0.35716419999994287;
		name = "GRAFICAS ALHOR";

		drawMarkers(lat, lng, name);

		// COPISTERIA ABASTOS
		lat = 39.467797313075664;
		lng = -0.3892221999999492;
		name = "COPISTERIA ABASTOS";

		drawMarkers(lat, lng, name);

		// MULTICOLOR
		lat = 38.357961212567574;
		lng = -0.4785957999999937;
		name = "MULTICOLOR";

		drawMarkers(lat, lng, name);

		// PAPELERIA ESTUDI
		lat = 38.99636371285796;
		lng = -0.16394690000004175;
		name = "PAPELERIA ESTUDI";

		drawMarkers(lat, lng, name);

		// REPROGRAFIA B.V., S.L.
		lat = 39.466706813075156;
		lng = -0.37535139999999956;
		name = "REPROGRAFIA B.V., S.L.";

		drawMarkers(lat, lng, name);

		// SAMARRETES PAPERS
		lat = 39.50720831309405;
		lng = -0.41511579999996684;
		name = "SAMARRETES PAPERS";

		drawMarkers(lat, lng, name);

		// URIBE DIGITAL
		lat = 39.465473913074604;
		lng = -0.38200370000004114;
		name = "URIBE DIGITAL";

		drawMarkers(lat, lng, name);

		// PANTERA ROSA
		lat = 39.48268981308261;
		lng = -0.3598785000000362;
		name = "PANTERA ROSA";

		drawMarkers(lat, lng, name);

		// VENTURA COPIN, S.L.
		lat = 39.8920136132742;
		lng = -0.08919890000004216;
		name = "VENTURA COPIN, S.L.";

		drawMarkers(lat, lng, name);

		// PAPELERIA COPISTERIA AEROCLUB, S.L.
		lat = 38.38545361257999;
		lng = -0.5084511999999677;
		name = "PAPELERIA COPISTERIA AEROCLUB, S.L.";

		drawMarkers(lat, lng, name);

		// REPROGRAFIA FACULTAT
		lat = 39.47819221308048;
		lng = -0.3605185999999776;
		name = "REPROGRAFIA FACULTAT";

		drawMarkers(lat, lng, name);

		// COPISTERIA EL CUQUET
		lat = 39.28872291299263;
		lng = -0.4150439999999662;
		name = "COPISTERIA EL CUQUET";

		drawMarkers(lat, lng, name);

		// LA PALLERA
		lat = 39.41938051305317;
		lng = -0.3979229999999916;
		name = "LA PALLERA";

		drawMarkers(lat, lng, name);
	}

	public void drawMarkers(Double lat, Double lng, String name) {
		googleMap.addMarker(new MarkerOptions().position(new LatLng(lat, lng))
				.title(name).anchor(0.5f, 0.5f));
	}

	public void comprobarPreferencias(String prefer1, boolean prefer2) {

		try {
			if (prefer1.equals("Nm"))
				googleMap.setMapType(GoogleMap.MAP_TYPE_NORMAL);
			else if (prefer1.equals("Hb"))
				googleMap.setMapType(GoogleMap.MAP_TYPE_HYBRID);
			else if (prefer1.equals("St"))
				googleMap.setMapType(GoogleMap.MAP_TYPE_SATELLITE);
			else if (prefer1.equals("Tr"))
				googleMap.setMapType(GoogleMap.MAP_TYPE_TERRAIN);
		} catch (Exception e) {
			// No hacemos nada
		}

		try {
			if (prefer2) {
				// Ponemos la aplicacin a pantalla completa
				getWindow()
						.addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
				getWindow().clearFlags(
						WindowManager.LayoutParams.FLAG_FORCE_NOT_FULLSCREEN);
			} else {
				// Desactivamos la opcin de pantalla completa
				getWindow().addFlags(
						WindowManager.LayoutParams.FLAG_FORCE_NOT_FULLSCREEN);
				getWindow().clearFlags(
						WindowManager.LayoutParams.FLAG_FULLSCREEN);
			}
		} catch (Exception e) {
			// No hacemos nada
		}
	}
}
