package com.dacober.avar;

import java.util.ArrayList;
import java.util.List;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;

import com.dacober.avar.MySQLiteOpenHelper.TablaFavoritos;

public class FavoritosDataSource {
	private SQLiteDatabase db;
	private MySQLiteOpenHelper dbHelper;
	private String[] columnas = { TablaFavoritos.COLUMNA_ID,
			TablaFavoritos.COLUMNA_REPRO };

	public FavoritosDataSource(Context context) {
		dbHelper = new MySQLiteOpenHelper(context);
	}

	public void open() {
		db = dbHelper.getWritableDatabase();
	}

	public void close() {
		dbHelper.close();
	}

	public void crearFavorito(String favorito) {
		ContentValues values = new ContentValues();
		values.put(TablaFavoritos.COLUMNA_REPRO, favorito);
		db.insert(TablaFavoritos.TABLA_FAVORITOS, null, values);
	}

	public List<Fav> getAllFavoritos() {
		List<Fav> listaFavoritos = new ArrayList<Fav>();

		Cursor cursor = db.query(TablaFavoritos.TABLA_FAVORITOS, columnas, null, null,
				null, null, null);
		cursor.moveToFirst();
		while (!cursor.isAfterLast()) {
			Fav nuevoFav = cursorToFav(cursor);
			listaFavoritos.add(nuevoFav);
			cursor.moveToNext();
		}

		cursor.close();
		return listaFavoritos;
	}

	public void borrarFavorito(Fav favorito) {
		long id = favorito.getId();
		db.delete(TablaFavoritos.TABLA_FAVORITOS, TablaFavoritos.COLUMNA_ID + " = " + id,
				null);
	}

	private Fav cursorToFav(Cursor cursor) {
		Fav favorito = new Fav();
		favorito.setId(cursor.getLong(0));
		favorito.setTexto(cursor.getString(1));
		return favorito;
	}
}
