package com.dacober.avar;

import java.util.List;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ListView;
import android.widget.Toast;

import com.actionbarsherlock.app.SherlockDialogFragment;

public class FragmentFavAvar extends SherlockDialogFragment {

	/** Inicializamos las diferentes variables. */
	private View rootView;
	private ListView favList;
	private FavoritosDataSource dataSource;
	// Creamos un adapter personalizado
	MenuFavAdapter adapter;

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		rootView = inflater.inflate(R.layout.favoritos_avar, container, false);

		// Evitamos que salga el patrocinador
		View LLPatrocinador = (View) getActivity().findViewById(
				R.id.LLPatrocinador);
		LLPatrocinador.setVisibility(View.GONE);

		return rootView;
	}

	public void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
		favList = (ListView) getActivity().findViewById(R.id.lvFavoritos);

		// Instanciamos FavoritosDataSource para
		// poder realizar acciones con la base de datos
		dataSource = new FavoritosDataSource(getActivity().getBaseContext());
		dataSource.open();

		// Cargamos la lista con los favoritos disponibles
		List<Fav> listaFavoritos = dataSource.getAllFavoritos();

		if (!listaFavoritos.isEmpty()) {
			adapter = new MenuFavAdapter(getActivity(), listaFavoritos);
			// Establecemos el adapter
			favList.setAdapter(adapter);
		} else {
			Toast.makeText(getActivity().getBaseContext(),
					"No existe ninguna reprografa en Favoritos",
					Toast.LENGTH_LONG).show();
		}

		favList.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {

				Fav favorito = (Fav) parent.getItemAtPosition(position);
				String nRepro = favorito.getnombre();

				Intent i = new Intent(getActivity().getBaseContext(),
						AvarInfo.class);
				i.putExtra("name", nRepro);
				startActivity(i);

			}
		});

		favList.setOnItemLongClickListener(new OnItemLongClickListener() {
			@Override
			public boolean onItemLongClick(final AdapterView<?> arg0,
					View arg1, final int position, long arg3) {

				AlertDialog.Builder alert = new AlertDialog.Builder(
						getActivity());

				alert.setTitle("Delete");
				alert.setMessage("Desea eliminar este item?");
				alert.setPositiveButton("S", new OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						// Borramos de la BD el item seleccionado
						Fav favorito = (Fav) arg0.getItemAtPosition(position);
						dataSource.borrarFavorito(favorito);

						// Refrescamos la lista
						refrescarLista();
					}
				});
				alert.setNegativeButton("No", new OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						// TODO Auto-generated method stub
						dialog.dismiss();
					}
				});

				alert.show();

				return true;
			}
		});
	}

	private void refrescarLista() {
		List<Fav> listaFavoritos = dataSource.getAllFavoritos();

		if (!listaFavoritos.isEmpty()) {
			adapter = new MenuFavAdapter(getActivity(), listaFavoritos);
			// Establecemos el adapter de nuevo
			favList.setAdapter(adapter);
		}
	}
}