package com.dacober.avar;

import java.io.IOException;
import java.io.InputStream;

import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;

import com.actionbarsherlock.app.SherlockFragment;

public class FragmentPatrocinador extends SherlockFragment {

	/** Inicializamos las diferentes variables. */
	WebView infoPatrocinador;
	InputStream info;
	View rootView;

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);

		// Evitamos que salga el patrocinador
		View LLPatrocinador = (View) getActivity().findViewById(
				R.id.LLPatrocinador);
		LLPatrocinador.setVisibility(View.GONE);

		infoPatrocinador = (WebView) rootView.findViewById(R.id.WvPatrocinador);

		infoPatrocinador.setVerticalScrollBarEnabled(false);
		infoPatrocinador.setHorizontalScrollBarEnabled(false);

		// Hacemos esto para evitar el bug del Hardware Accelerator en versiones
		// superiores a 3.0
		infoPatrocinador.setBackgroundColor(Color.parseColor("#919191"));

		// Empezamos a leer el fichero con la informacin a cargar
		try {
			info = getActivity().getAssets().open("infoPatrocinador.txt");
			int tam = info.available();
			byte[] buffer = new byte[tam];
			info.read(buffer);
			info.close();

			// Cargamos en el WebView la informacin contenida en el buffer
			infoPatrocinador.loadDataWithBaseURL("", (new String(buffer)), "text/html",
					"utf-8", "");

		} catch (IOException ioex) {
			Log.e("Error en el fichero assets: ", ioex.getMessage());
		}
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		rootView = inflater.inflate(R.layout.patrocinador, container, false);

		return rootView;
	}

}
